`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 19.10.2022 10:03:36
// Design Name: 
// Module Name: premphasis
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module premphasis #(parameter N=18,precision=10,constant = 'd972)(clk,reset,y,yout);
input clk,reset;
input [N-1:0] y;
output [N-1:0] yout;
wire [N-1:0] y1,y2,y3,y4;
regN #(N) rg1(y1,clk,reset,y);

multN #(N,precision) mult1(y1, constant, y2);
regN #(N) rg3(y3,clk,reset,y2);

adsubN #(N) ad1(1'b1,y1,y3,y4);
regN #(N) rg4(yout,clk,reset,y4);
endmodule

module multN #(parameter N=18,
				  parameter precision = 0)
					(a, b, p);
  input signed [N-1:0] a,b;
  output [N -1:0] p;
  wire [2*N - 1:0] p1;
  assign p1 = a*b;
  assign p = p1[N -1 + precision:precision];
endmodule

module adsubN #(parameter N = 18)(input sel,input [N-1:0] a,b,
output [N-1:0] s
    );
assign s = (sel)?(a-b):(a+b);

endmodule

module regN #(parameter N=18)(y,clk,reset,a);
    input [N-1:0] a;
    output reg [N-1:0] y;
    input clk,reset;
 
always @(posedge clk)
if (reset)
y <= 0;
else
y <= a;
endmodule