`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 19.10.2022 10:04:20
// Design Name: 
// Module Name: premphasis_top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module premphasis_top #(parameter N=16,precision =10,constantpre='d972)(clk,reset,start,led);
input clk,reset,start;
output [N-1:0] led;
wire [N-1:0] x;  
wire [5:0] ada;
wire tc,tc1,en,start1;
///start signal generation
start_signal_generation insig(clk,reset,start,start1);//start signal by pushbutton...
///input Rom and rom output logic...
inputmemory #(N,6) m1(ada,en,clk,x);///rom which stores the data
pgbh pg1(start1|tc1,tc,en,clk,reset);//generating the en signal for counter
counterupN #(6) cnt1(ada,6'd0,tc,en,clk,reset,tc,6'd63);//0 to 63...
general_delay_block #(1,4) dly(clk,reset,tc,tc1);///2nd set of input is read after 4 clock cycles

////main premphasis block
premphasis #(N,precision,constantpre) premh(clk,reset,x,led);					  
endmodule

module counterupN #(parameter N = 10)(count,data,load,en,clk,reset,tc,lmt);
output [N-1:0] count;
output reg tc;
input [N-1:0] data,lmt;
input load, en, clk,reset;
reg [N-1:0] count;

always @(posedge clk)
if (reset) begin
  count <= 1'b0 ;
end else if (load) begin
  count <= data;
end else if (en)
  count <= count + 1'b1;
else count <= count;
always @(*)
if (count ==lmt)
tc <=1;
else tc=0;
endmodule

module pgbh(start,stop,q,clk,reset);
	 input start,stop,clk,reset;
	 output reg q;
	 
always @(posedge clk)
begin
if (reset)
q = 0;
else if (start)
q = 1'b1;
else if(stop)
q = 1'b0;
end
endmodule

module general_delay_block #(parameter N=1,
									  parameter D = 4)(clk,reset,a,aN);
input clk,reset;
input [N-1:0] a;
output [N-1:0] aN;
wire [N-1:0] tmp [D:0];
assign tmp[0] = a;
generate
genvar p;
for (p = 1; p <= D; p = p+1) begin: General_delay
regN #(N) rg(tmp[p],clk,reset,tmp[p-1]);
end
endgenerate
assign aN = tmp[D];
endmodule